<?php
  /**
   * recurse direcory
   *
   * This function recurses into a given base directory
   * and calls the supplied function for each file and directory
   *
   * @param   array ref $data The results of the search are stored here
   * @param   string    $base Where to start the search
   * @param   callback  $func Callback (function name or arayy with object,method)
   * @param   string    $dir  Current directory beyond $base
   * @param   int       $lvl  Recursion Level
   * @author  Andreas Gohr <andi@splitbrain.org>
   * modified by Samuele Tognini <samuele@netsons.org>
   */
  function _search($base='data/pages')
  {
    $dirs   = array();
    $files  = array();
    $files_tmp=array();
    $dirs_tmp=array();

    //read in directories and files
    $dh = @opendir($base);
    if(!$dh) return array();
    while(($file = readdir($dh)) !== false){
		//skip hidden files and upper dirs
		if(preg_match('/^[\._]/',$file)) continue;
		if(is_dir($base.'/'.$file)){
			$tmp=_search($base.'/'.$file);
			foreach ($tmp as $t)
				$files[]=$t;
			continue;
		}
      $files[] = $base.'/'.$file;
    }
    closedir($dh);
	return $files;
  }
  
	function wyslij($pliki)
	{
		$fileswswi=array();
		$fil=fopen('tmp.pl',"w");
		$bledy=0;
		$r='';
		foreach ($pliki as $plik)
		{
			$kod=file_get_contents($plik,'FILE_TEXT');
			if ($kod=stristr($kod,'<SWP>'))
			{
				if ($gdzie=stripos($kod,"</SWP>"))
					{
					$kod=substr($kod,5,($gdzie-5));
					$m1=strpos($kod,'(');
					$m2=strpos($kod,")");
					if ($m1 && $m2 || CHECK==0)
					{
						if ($m1<$m2 || CHECK==0)
						{
							if ($kod[strlen($kod)-1]!=".")
								$kod.='.';
							$result='fake';
							if (CHECK==1)
							{
								$fil2=fopen('tmp2.pl',"w");
								fputs($fil2,$kod);
								fclose($fil2);
								$result=goal(substr($kod,0,$m1)."(X".")",0);
							}
							if (strlen($result)>0)
							{
								fputs($fil,$kod."\n");
								$fileswswi[]=$plik;
							}
						}
					}
					}
				else
				//nie ma tagu konczacego
					$bledy=1;
			}
		}
	fclose($fil);  
	return $fileswswi;
}  

function goal($c,$t=1)
{
	$w='swipl -f tmp.pl -g \''.$c.',writeln(X),fail.\'';
	if ($t==0)
		$w='swipl -f tmp2.pl -g \''.$c.',writeln(X),fail.\'';
	$r=shell_exec($w);
	return $r;
}

function save_core($files,$goal='')
{
	global $QUERY;
	$mkat=@opendir(DOKU_PLUGIN.'swp/pages');
	if (!$mkat)
		if (!mkdir(DOKU_PLUGIN.'swp/pages'))
			return 0;
	$names=array();
	$names=explode(":",$QUERY);
	$filename='';
	$i=0;
	foreach ($names as $name)
	{
		if ($i<count($names)-1)
			$filename.=$name.'/';
		$i++;
	}
	$filename=substr($filename,0,-1);
	if (!is_dir(DOKU_PLUGIN.'/swp/pages/'.$filename))
	{
		mkdir(DOKU_PLUGIN.'/swp/pages/'.$filename);
	}
	$fil=fopen(DOKU_PLUGIN.'/swp/pages/'.$filename.'/'.$names[count($names)-1].'.tpl',"w");
	foreach ($files as $file)
		fputs($fil, $file.' '.$goal."\n");
	fclose($fil);
	/*else
	{
		$fil=fopen(DOKU_PLUGIN.'/swp/pages/'.$QUERY.'.tpl',"w");
		foreach ($files as $file)
			fputs($fil, $file.' '.$goal."\n");
		fclose($fil);
	}*/
}
?>